<script setup lang="ts">
import { AuthService } from '@/services/auth';
import { useLoadingStore } from '@/stores/loading';
import { onMounted } from 'vue';
import { ref } from 'vue';
import type { VForm } from 'vuetify/components';

const isFormEmpty = ref(true)
const refForm = ref<VForm | null>(null)
const email = ref('')
const password = ref('')
const storeLoading = useLoadingStore()
const loading = storeLoading.isLoading

const currUser = ref()

onMounted(() => {
    updateCurrentUser()
})

function updateCurrentUser() {
    currUser.value = localStorage.getItem('user')
}

async function onSubmit() {
    try {
        storeLoading.doLoad()
        const valid = await refForm.value!.validate()
        if (valid) {
            const res = await AuthService.signIn(email.value, password.value)
            localStorage.setItem('jwt', JSON.stringify(res.data.access_token))
            localStorage.setItem('user', JSON.stringify(res.data.user))
        }
    } catch (e: any) {
        if (e.response.status === 401) {
            alert('No user found')
        } else {
            throw new Error
        }
    } finally {
        updateCurrentUser()
        storeLoading.finish()
    }
}

const required = (v: string) => !!v || 'Field is required'
</script>

<template>
    <v-card class="mx-auto px-6 py-8" max-width="344">
        <v-form ref="refForm" v-model="isFormEmpty" @submit.prevent="onSubmit">
            <v-text-field v-model="email" :readonly="loading" :rules="[required]" class="mb-2" clearable
                label="Email"></v-text-field>

            <v-text-field v-model="password" :readonly="loading" :rules="[required]" clearable label="Password"
                placeholder="Enter your password"></v-text-field>
            <br>
            <v-btn :disabled="!isFormEmpty" :loading="loading" block color="success" size="large" type="submit"
                variant="elevated">
                Sign In
            </v-btn>
        </v-form>
    </v-card>
    <h1>
        Current User : {{ currUser }}
    </h1>
</template>